︠709b9987-789c-4bf5-88d5-b589b6ab7cb5i︠
%md
# Finite Fields (more)
## William Stein
## Jan 22, 2016


**Motivation:** if you plan to ever do any computations over finite fields, today is going to make your life easier later.  Simple as that.
︡670d51ce-599c-406f-98e3-518e7bd14a5f︡︡{"done":true,"md":"# Finite Fields (more)\n## William Stein\n## Jan 22, 2016\n\n\n**Motivation:** if you plan to ever do any computations over finite fields, today is going to make your life easier later.  Simple as that."}
︠6d8e0dd7-24df-41c1-9d3b-697d86551ab3i︠
%md
### Update on the "saga" of `GF(9)`.
︡a43e3d37-c8c8-40d7-ba6f-06827a19112e︡︡{"done":true,"md":"### Update on the \"saga\" of `GF(9)`."}
︠3b628a00-fba3-41d6-b156-0aad1b582841s︠
# Recall
GF(9)   # expected "boom"
︡b278fa65-cc0c-4db7-90aa-4ec55e0759c1︡︡{"done":false,"stderr":"Error in lines 2-2\nTraceback (most recent call last):\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 905, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"sage/structure/factory.pyx\", line 364, in sage.structure.factory.UniqueFactory.__call__ (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/factory.c:1245)\n    key, kwds = self.create_key_and_extra_args(*args, **kwds)\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/sage/rings/finite_rings/constructor.py\", line 479, in create_key_and_extra_args\n    raise ValueError(\"parameter 'conway' is required if no name given\")\nValueError: parameter 'conway' is required if no name given\n"}︡{"done":true}
︠c34480de-823c-4be0-aed2-90ef23481185s︠
# but...
GF(9,'a')
︡f2004136-af7b-4317-870a-3d6bbc1e9eff︡︡{"stdout":"Finite Field in a of size 3^2\n","done":false}︡{"done":true}
︠e24a3f91-46a7-4094-aad5-cc2cec7b9cfdi︠
%md
Then Nathann Cohen complained, which led to a huge thread and this ticket: http://trac.sagemath.org/ticket/19929

- some discussion
- a rude/mean comment from Nathann directed at me...
- ticket closed
- another ticket: http://trac.sagemath.org/ticket/17569

It looks like doing `GF(9)` might in the near future construct the quadratic subfield of $\bar{\FF}_{3}$.
Is this a good idea?  What is $\bar{\FF}_p$ in Sage anyways?

<br/>
Let's find out!
︡dce4b4d8-aa07-4026-9709-a33142b737fb︡︡{"done":true,"md":"Then Nathann Cohen complained, which led to a huge thread and this ticket: http://trac.sagemath.org/ticket/19929\n\n- some discussion\n- a rude/mean comment from Nathann directed at me...\n- ticket closed\n- another ticket: http://trac.sagemath.org/ticket/17569\n\nIt looks like doing `GF(9)` might in the near future construct the quadratic subfield of $\\bar{\\FF}_{3}$.\nIs this a good idea?  What is $\\bar{\\FF}_p$ in Sage anyways?\n\n<br/>\nLet's find out!"}
︠f5009a40-20bc-47f4-94f9-a9ba76fed32d︠

︠8f3f1450-1ae8-4790-a5b7-558f8d72240c︠

︠bf2cbbee-2532-4f1c-86a2-8ab261081aef︠

︠c64a8c9a-57a9-45dc-ab9b-2ca5705c1f8bi︠
%md
### The lattice of finite fields...?
︡d1e0f044-cf80-419d-92b2-cc3efab84155︡︡{"done":true,"md":"### The lattice of finite fields...?"}
︠fbd431db-99a3-4539-bf24-011ee9276313s︠
F2.<a> = GF(3^2)
F3.<b> = GF(3^3)
a + b  # Sage doesn't magically do this...
︡bb630815-cb87-44db-8df7-b66afde22153︡︡{"done":false,"stderr":"Error in lines 3-3\nTraceback (most recent call last):\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 905, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"sage/structure/element.pyx\", line 1651, in sage.structure.element.RingElement.__add__ (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/element.c:15852)\n    return coercion_model.bin_op(left, right, add)\n  File \"sage/structure/coerce.pyx\", line 1069, in sage.structure.coerce.CoercionModel_cache_maps.bin_op (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/coerce.c:9736)\n    raise TypeError(arith_error_message(x,y,op))\nTypeError: unsupported operand parent(s) for '+': 'Finite Field in a of size 3^2' and 'Finite Field in b of size 3^3'\n"}︡{"done":true}
︠e1b555c4-d660-4b95-88f0-aafa8f559522i︠
%md
### Bummer?

No, not really...

There's no reason to expect a+b to make any sense in Sage, since we have two
finite fields above with two different variable.
Also, if the names were the same, it also wouldn't make sense, because then $a$ would
be the generator of $\FF_{3^2}$ and $\FF_{3^3}$ simultaneously.

︡eb2c0838-c923-4ba2-93d8-b4a62b95e18f︡︡{"done":true,"md":"### Bummer?\n\nNo, not really...\n\nThere's no reason to expect a+b to make any sense in Sage, since we have two\nfinite fields above with two different variable.\nAlso, if the names were the same, it also wouldn't make sense, because then $a$ would\nbe the generator of $\\FF_{3^2}$ and $\\FF_{3^3}$ simultaneously."}
︠3e42aa28-46a6-464d-894c-d23f1a805488i︠
%md
Incidentally, Magma doesn't care what you call things, and does make sense of adding the $a$ and $b$ defined above:
︡0cad3c8a-19d6-4590-b711-3b46e41864da︡︡{"done":true,"md":"Incidentally, Magma doesn't care what you call things, and does make sense of adding the $a$ and $b$ defined above:"}
︠68606f6b-f5ad-46d3-94cc-bf25d12851e0︠
%magma    /* magma does */
F2<a> := FiniteField(3^2);
F3<b> := FiniteField(3^3);
a + b
︡e3edabee-da4c-4fa9-b636-64fe9b33cb1e︡︡{"stdout":"\n\n$.1^297","done":false}︡{"done":true}
︠9e9a51d3-64c2-450a-b9c9-3e383c6957d1i︠
%md
### Back to Sage...

At least we can do everything very explicitly and define embeddings.
︡f7fff47f-143c-420c-a7ca-f82231cfe23c︡︡{"done":true,"md":"### Back to Sage...\n\nAt least we can do everything very explicitly and define embeddings."}
︠49646106-a01c-429d-8ce6-cb2ac344ff4cs︠
F2.<a> = GF(3^2)
F3.<b> = GF(3^3)
F6.<c> = GF(3^6)
︡1e799f44-0395-41a9-beaa-3f2a4e8f0520︡︡{"done":true}
︠90d6e5ad-eba0-4ac4-9e3a-a413c26d70c1s︠
# Sadly, there is no "embeddings" command to produce all finite field morphisms from
# one field into another, which would be EASY to write (see below):
F2.embeddings
︡451c78e4-aa79-4f09-9285-73832dacb029︡︡{"done":false,"stderr":"Error in lines 3-3\nTraceback (most recent call last):\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 905, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"sage/structure/parent.pyx\", line 859, in sage.structure.parent.Parent.__getattr__ (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/parent.c:8131)\n    attr = getattr_from_other_class(self, self._category.parent_class, name)\n  File \"sage/structure/misc.pyx\", line 253, in sage.structure.misc.getattr_from_other_class (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/misc.c:1667)\n    raise dummy_attribute_error\nAttributeError: 'FiniteField_givaro_with_category' object has no attribute 'embeddings'\n"}︡{"done":true}
︠ee72516f-df83-4918-b30b-69507992c3e8s︠
# First get the roots of the defining polynomial of F2 in the field F6.
v = F2.polynomial().roots(ring=F6, multiplicities=False); v
︡98dbec5a-6d3b-4311-b351-e1ee29843131︡︡{"stdout":"[2*c^5 + 2*c^3 + c^2 + 2*c + 2, c^5 + c^3 + 2*c^2 + c + 2]","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠7796e4d3-1e8f-45f0-83ad-2bc066485781s︠
phi = Hom(F2, F6)(v[0])
phi
︡db47b86a-d7ae-414b-9581-ddd480059d68︡︡{"stdout":"Ring morphism:\n  From: Finite Field in a of size 3^2\n  To:   Finite Field in c of size 3^6\n  Defn: a |--> 2*c^5 + 2*c^3 + c^2 + 2*c + 2\n","done":false}︡{"done":true}
︠a75458cb-b04f-4fb6-b406-5ba8197efdd4s︠
phi(a)
︡4aa58e65-d47c-4da3-b1ea-f874e3a44d5f︡︡{"stdout":"2*c^5 + 2*c^3 + c^2 + 2*c + 2\n","done":false}︡{"done":true}
︠515e777b-58ac-42db-b234-c1f9a94d419ds︠
def embeddings(E, F):
    """Compute all embeddings from the field E into the field F."""
    H = Hom(E,F)
    return [H(x) for x in E.polynomial().roots(ring=F, multiplicities=False)]
︡01e395c8-fec3-4685-a949-e8b1c0c9c58b︡︡{"done":true}
︠4c169cfd-9c34-462a-8644-18d20ca35ae9s︠
embeddings(GF(9,'a'), GF(3).algebraic_closure())
︡2a989143-2463-4a98-8f63-34d2f2077893︡︡{"stdout":"[Ring morphism:\n  From: Finite Field in a of size 3^2\n  To:   Algebraic closure of Finite Field of size 3\n  Defn: a |--> z2, Ring morphism:\n  From: Finite Field in a of size 3^2\n  To:   Algebraic closure of Finite Field of size 3\n  Defn: a |--> 2*z2 + 1]\n","done":false}︡{"done":true}
︠4cb47434-da0b-4060-a1ea-72864557e936s︠
def embeddings(E, F):
    """Compute all embeddings from the field E into the field F."""
    H = Hom(E,F)
    return [H(x) for x in E.polynomial().roots(ring=F, multiplicities=False)]
︡14c11ffd-e750-4684-a147-70c5c9cd8c76︡︡{"done":true}
︠27f9eb97-477c-42ef-a8c4-08a5415aaa66︠

︠7b4d85da-3783-43f0-a61f-830bd03f640fs︠
def embeddings(E, F):
    """Compute all embeddings from the field E into the field F."""
    return list(Hom(E,F))
︡2999aec0-85b2-4621-b2e3-3d125dbfe41f︡︡{"done":true}
︠30ffce70-a4fd-4c71-9093-565cde1044fcs︠
H = Hom(F2, F6)
︡e7781580-d609-4811-9f75-c80c9729e8c7︡︡{"done":true}
︠4371f10c-ad8d-46a7-aedd-8e9727db93b7s︠
H.list??
︡dc89c10f-9469-4979-93cc-65ca33454b6b︡
︠281da1a1-bd2f-40b6-895d-5dc5743ca03ds︠
psi = embeddings(F3,F6)[0]
psi
︡bd8789db-0863-4fdd-9a7d-b8bbd6ade0d4︡︡{"stdout":"Ring morphism:\n  From: Finite Field in b of size 3^3\n  To:   Finite Field in c of size 3^6\n  Defn: b |--> 2*c^5 + 2*c^4\n","done":false}︡{"done":true}
︠5b819505-9e7b-4faa-99e0-e7bdd68922e5s︠
psi(b)
︡5e45297e-479a-4b1f-a96a-7d5513806126︡︡{"stdout":"2*c^5 + 2*c^4\n","done":false}︡{"done":true}
︠95318b8e-0980-4d05-a57a-90b419d47c65s︠
# Finally, compute the sum in F6:
%timeit phi(a) + psi(b)
︡aa754ad1-e9fb-4eba-ab2c-fe8d62e06991︡︡{"stdout":"625 loops, best of 3: 214 µs per loop","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠9570645c-b02c-4b22-8536-730af7f2685es︠
# this takes a lot of time though:
%timeit phi(a) + psi(b)
︡1947baab-fef8-4342-ba8a-f79be91382c0︡︡{"stdout":"625 loops, best of 3: 146 µs per loop","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠d64ee1fc-edd1-40d7-95af-cd87725a2d97︠

︠01ab6c1c-f917-477f-9d1e-e81b9b13ff30︠

︠a9fbd2b8-aba5-4429-9a5d-3607d4e45f2a︠

︠99f6bdab-c412-47ad-8a70-5e6a25ab613d︠

︠73c45415-a554-4642-8e53-4bdade3949bbi︠
%md
So... at least it's possible to play around with different finite fields.

Though, as you might imagine, this "naive" appraoch can get very confusing and problematic!
What if you do some more computations, choosing embeddings, and end up with two different
ways to get from $\FF_{3^2}$ to $\FF_{3^{12}}$, say?  In a program it could happen very naturally,
and lead to subtle bugs.
︡dafe1d20-0f10-48c6-b0fb-0af5bb90087e︡︡{"done":true,"md":"So... at least it's possible to play around with different finite fields.\n\nThough, as you might imagine, this \"naive\" appraoch can get very confusing and problematic!\nWhat if you do some more computations, choosing embeddings, and end up with two different\nways to get from $\\FF_{3^2}$ to $\\FF_{3^{12}}$, say?  In a program it could happen very naturally,\nand lead to subtle bugs."}
︠003dd7ec-5b3b-4273-8422-5710bbb6fd46︠


︠b17a9888-4313-4dba-b4d8-89ea1f0cdc9di︠
%md
However, Sage **does** support working in $\overline{\FF}_p$, which is possibly very nice and solves our problem in a
way that doesn't run into subtle bugs/contradictions if things get more complicated.
︡180cd412-b599-4834-9a76-e10f5ea7ebb2︡︡{"done":true,"md":"However, Sage **does** support working in $\\overline{\\FF}_p$, which is possibly very nice and solves our problem in a\nway that doesn't run into subtle bugs/contradictions if things get more complicated."}
︠e800abce-00ea-41dc-bcae-19340f8324e2s︠
Fbar = GF(3).algebraic_closure()
Fbar
︡f68c0796-da52-437b-8221-5e7c83280eb3︡︡{"stdout":"Algebraic closure of Finite Field of size 3\n","done":false}︡{"done":true}
︠3cb07891-bd17-4e01-b13c-181c1bd6395as︠
# Heh, somebody should implement latex(Fbar) -- it would be so easy...
latex(Fbar)
︡292dc0c2-3bee-4ccf-91ab-7be70e061023︡︡{"stdout":"\\text{\\texttt{Algebraic{ }closure{ }of{ }Finite{ }Field{ }of{ }size{ }3}}\n","done":false}︡{"done":true}
︠cf3ffb33-c85a-4090-8066-98a0e7f3a6eas︠
QQ.algebraic_closure()
︡27b56040-4812-4282-b09a-8d8473cb8795︡︡{"stdout":"Algebraic Field\n","done":false}︡{"done":true}
︠ba13ef14-4b7d-457e-aaa1-0d26b053158cs︠
latex(QQ.algebraic_closure())
︡82fd3863-37d9-40d7-8e3c-1bbd5ab11ca5︡︡{"stdout":"\\overline{\\QQ}\n","done":false}︡{"done":true}
︠1ee39d40-f403-45d2-8c98-44f78f1ca7b2s︠
g2 = Fbar.gen(2); g2
g3 = Fbar.gen(3); g3
g2 + g3
︡806359ce-0d08-4d12-8fe3-ef9f1e378881︡︡{"stdout":"z2\n","done":false}︡{"stdout":"z3\n","done":false}︡{"stdout":"z6^5 + 2*z6^4 + 2*z6^3 + z6^2 + 2*z6 + 1\n","done":false}︡{"done":true}
︠8b1ce901-0bc9-4c09-acd5-78edc63cbf6as︠
%timeit g2 + g2
︡5d5a04a0-130a-47d7-b1e0-32447abaaaf6︡︡{"stdout":"625 loops, best of 3: 385 µs per loop","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠8c6a9fb8-6c4d-407e-8d6c-e04055b0c135s︠
a = Fbar.subfield(2)[0].0
%timeit a+a
︡1fb41e0c-ac14-4dc0-98d4-b4b31983afbd︡︡{"stdout":"625 loops, best of 3: 120 ns per loop\n","done":false}︡{"done":true}
︠6f501f8d-52af-4308-a743-5577619d1aa7s︠
f = Fbar.subfield(2)[1]
︡b1727b74-c382-465d-afa1-3a134e0dbe49︡︡{"done":true}
︠c99345b9-dcb9-4b70-bd7c-83724e360cacs︠
f.inverse_image(g2)
︡2f2eb666-8018-49bd-9182-9ad6f3055582︡︡{"done":false,"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 905, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"sage/rings/morphism.pyx\", line 884, in sage.rings.morphism.RingHomomorphism.inverse_image (/projects/sage/sage-6.10/src/build/cythonized/sage/rings/morphism.c:6716)\n    raise NotImplementedError\nNotImplementedError\n"}︡{"done":true}
︠e3bfff73-7a1c-437f-b937-0f9e8297c637︠
(g2+g3).minpoly()
︡b36d2622-4716-4fe5-b057-96177fd0bb78︡︡{"stdout":"x^6 + x^4 + 2*x^3 + x^2 + x + 2\n","done":false}︡{"done":true}
︠8c2bbed9-c9f3-4cc0-a28b-8bed411f68e0s︠
g2*g3
︡bd527978-b275-407b-8f83-647ebe37cab2︡︡{"stdout":"z6^5 + 2*z6^4 + z6^2 + 2\n","done":false}︡{"done":true}
︠41e2e0fa-095c-4228-94e6-1228d958932bs︠
F6, f = Fbar.subfield(6)
F6
f
︡dda743bb-7e5e-439c-a6de-f77872df67ce︡︡{"stdout":"Finite Field in z6 of size 3^6\n","done":false}︡{"stdout":"Ring morphism:\n  From: Finite Field in z6 of size 3^6\n  To:   Algebraic closure of Finite Field of size 3\n  Defn: z6 |--> z6\n","done":false}︡{"done":true}
︠f02c128e-87cf-42d0-80cb-795d2865ecdc︠
f(F6.0)
︡dd9a92b7-d52a-4c35-aa61-b0be7e09ee92︡︡{"stdout":"z6\n","done":false}︡{"done":true}
︠39ef67e2-3499-47da-9949-a5f05c30a842s︠
F6.0 + g2 + g3
︡97e86725-c3ab-4c8c-8202-2cd22588a4b0︡︡{"stdout":"z6^5 + 2*z6^4 + 2*z6^3 + z6^2 + 1\n","done":false}︡{"done":true}
︠1f024c27-0c01-46bf-aad8-00aad8d6b949︠

︠c90c734f-b557-4eb5-af3d-55c692a97a1e︠

︠356bae76-d01b-4c05-98e2-a3645e4c3d7ai︠
%md

**Exercise:** Whenever you try anything in software you should be very worried that the implementation sucks. You should run some basic benchmarks and compare with what you know. Never trust anything (especially do not use closed source software). Is Fbar slow or fast? Try some simple benchmarks right now.


︡ab79effc-3520-4a60-8624-b30ce6d3d0ee︡︡{"done":true,"md":"\n**Exercise:** Whenever you try anything in software you should be very worried that the implementation sucks. You should run some basic benchmarks and compare with what you know. Never trust anything (especially do not use closed source software). Is Fbar slow or fast? Try some simple benchmarks right now."}
︠3e6d4936-4b7a-4f7e-bb56-a9343aca0ba8s︠
# 1. Benchmark (using %timeit) adding/multiplying g2 with itself here:


︡8e1a5084-c0fa-4389-9013-7f9a6115f620︡︡{"done":true}
︠3843ee1e-1fbb-4d96-9547-d91fc12a6757︠

︠6abd1508-10b0-4cae-acee-d0d6344437f4︠

︠434efb04-fe35-45fe-ae78-e71c374839e2︠

︠8f893607-5fcb-4eef-89b8-7806ac66490a︠
# 2. Benchmark (using %timeit) adding/multiplying g2 with g3 (which results in an element of F6):


︡8f1ceb89-6f99-41e5-a000-0c4c6b9cff72︡︡{"done":true}
︠a0392c5b-5435-4fff-a9de-614d8946de45︠

︠82e39ef8-4cf2-4f18-881f-9bad5052781a︠

︠29fd60d0-7916-4cf9-b33e-6c598a1c5f0cs︠
# 3. CRITICAL: How does the benchmark in 2 compare to what we did above?
︡e996f08d-e5cb-4056-bb4f-2685087ae8f3︡︡{"done":true}
︠c09eaaa5-3012-4ea7-8d43-1d6e044f8e04︠

︠b09663ec-22bb-4cfc-bccc-e131bc14f677︠

︠d7b92340-6d2a-4962-96ee-42f00cdc29b2︠

︠c14d01f6-3482-493b-baec-77160b9e83c5i︠
%md
### How does $\overline{\FF}_p$ in Sage work?

The main idea is to use pseudo-conway polynomials, which are conway polynomials without the lexicographic condition.

**Definition:** Suppose $f_n$ is the minimal polynomial of a generator $a$ of $\FF_{p^n}^*$.  For $m<n$, let $a^r$ be the smallest power of $a$ that generators $\FF_{p^m}$, and let $f_m$ be the minimal polynomial of $a^r$.  Say that $f_n$ and $f_m$ are **compatible** of $f_m$ divides $f_n$.

We call $f_n$ a **pseudo-Conway polynomial** if it is compatible with $f_m$ for all $m<n$.  This means that you can very easily understand the subfields of $\FF_{p^n}$ and maps between them explicitly in terms of these polynomials.

Of course finding a pseudo-Conway polynomial isn't trivial.

To make it even harder, you could try to find a **Conway polynomial** which is the same as above, except you require all the $f_n$ to be lexicographically minimal.

︡535f5c69-1863-483f-a6da-f876b3decaff︡︡{"done":true,"md":"### How does $\\overline{\\FF}_p$ in Sage work?\n\nThe main idea is to use pseudo-conway polynomials, which are conway polynomials without the lexicographic condition.\n\n**Definition:** Suppose $f_n$ is the minimal polynomial of a generator $a$ of $\\FF_{p^n}^*$.  For $m<n$, let $a^r$ be the smallest power of $a$ that generators $\\FF_{p^m}$, and let $f_m$ be the minimal polynomial of $a^r$.  Say that $f_n$ and $f_m$ are **compatible** of $f_m$ divides $f_n$.\n\nWe call $f_n$ a **pseudo-Conway polynomial** if it is compatible with $f_m$ for all $m<n$.  This means that you can very easily understand the subfields of $\\FF_{p^n}$ and maps between them explicitly in terms of these polynomials.\n\nOf course finding a pseudo-Conway polynomial isn't trivial.\n\nTo make it even harder, you could try to find a **Conway polynomial** which is the same as above, except you require all the $f_n$ to be lexicographically minimal."}
︠86af3c34-ffdc-4fd7-be9f-0e1ea1a6c85d︠

︠e0ca35f3-90a1-4fd1-bdd0-31cf583fa6c9︠

︠2ddb253f-203c-40ba-b462-f574ad94f7dai︠
%md
**Exercise:** Compare field creation time.
︡a7a2eda3-eb66-44ee-91a4-1d7abc663720︡︡{"done":true,"md":"**Exercise:** Compare field creation time."}
︠92579804-153f-4fdb-a0b6-bf9ad7a4efd0s︠
# 1. Something small using timeit (which might be very misleading?) -- just try changing 3 to something small
%timeit GF(3^6,'a')
%timeit GF(3).algebraic_closure().subfield(6)
︡6cdc809f-3491-46a2-8679-4c8d377daff6︡{"stdout":"625 loops, best of 3: 277 µs per loop","done":false}︡{"stdout":"\n","done":false}︡{"stdout":"625 loops, best of 3: 641 µs per loop","done":false}︡{"stdout":"\n","done":false}︡{"done":true}︡
︠6f0e5be8-5793-44d6-acd5-2f7e03fcdf1f︠

︠eb39d710-adf6-4dee-8ac8-c80d90329e93︠
# 2. Something bigger: make p a prime with about 10 digits and the extension of degree 6.
p = next_prime(  # figure it out ...)
%time GF(p^6, 'a')
%time GF(p).algebraic_closure().subfield(6)
︡d210519c-c958-491d-a224-83f67643ad05︡
︠9c69bd43-ed23-4dcd-868c-751b5e59bd63︠


︠1a330fe0-1661-47e4-badc-46bd9afd3012︠

︠89f68132-6cfd-4a93-9021-eeabaadf2795︠

︠26f10393-3371-457b-bda0-12f76dcdc287︠
# 3. Something bigger: make p a prime with about 20 digits and the extension of degree 6.
︠c7d314c5-10de-4861-be96-6b1a30e9e753︠

︠fe452ff0-d8e0-471d-b1e2-07f172fcee6d︠

︠6b5cd754-2f5b-4f43-9be8-2db88cd50747︠

︠fec32b3c-556b-4169-aaf2-be88105c5706︠

︠aebfab28-bff1-4cee-bcc4-577bd7b40e47i︠
%md
Next time (again delayed): finite fields from prime ideals in rings of integers of number fields
︡ff535a69-5b64-4031-8f86-205e80f6ae2a︡︡{"done":true,"md":"Next time (again delayed): finite fields from prime ideals in rings of integers of number fields"}
︠b634e51b-e439-4384-9521-b99b38202757︠
︠3d1dc542-1f2a-4e1f-835a-c091fc613f51︠









